/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.69 Revision 1.114
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.69 2010/05/24 14:27:13 wired Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.114 2012/01/01 18:12:03 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 12inherit base eutils multilib toolchain-funcs flag-o-matic versionator
16 13
17MY_PV=${PV/_/-} 14MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 15MY_P=qt-everywhere-opensource-src-${MY_PV}
16
17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/"
18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
19LICENSE="|| ( LGPL-2.1 GPL-3 )"
20
21IUSE="aqua debug pch"
22
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE="+exceptions" 23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] &&
21else 24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
22 MY_P=qt-x11-opensource-src-${MY_PV} 25 IUSE+=" +exceptions"
26
27if version_is_at_least 4.7.99999999; then
28 IUSE+=" c++0x qpa"
23fi 29fi
24 30
25HOMEPAGE="http://qt.nokia.com/" 31DEPEND="dev-util/pkgconfig"
26SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
27
28LICENSE="|| ( LGPL-2.1 GPL-3 )"
29IUSE+=" debug pch aqua"
30
31RDEPEND=" 32RDEPEND="
32 !<x11-libs/qt-assistant-${PV} 33 !<x11-libs/qt-assistant-${PV}
33 !>x11-libs/qt-assistant-${PV}-r9999 34 !>x11-libs/qt-assistant-${PV}-r9999
34 !<x11-libs/qt-core-${PV} 35 !<x11-libs/qt-core-${PV}
35 !>x11-libs/qt-core-${PV}-r9999 36 !>x11-libs/qt-core-${PV}-r9999
36 !<x11-libs/qt-dbus-${PV} 37 !<x11-libs/qt-dbus-${PV}
37 !>x11-libs/qt-dbus-${PV}-r9999 38 !>x11-libs/qt-dbus-${PV}-r9999
39 !<x11-libs/qt-declarative-${PV}
40 !>x11-libs/qt-declarative-${PV}-r9999
38 !<x11-libs/qt-demo-${PV} 41 !<x11-libs/qt-demo-${PV}
39 !>x11-libs/qt-demo-${PV}-r9999 42 !>x11-libs/qt-demo-${PV}-r9999
40 !<x11-libs/qt-gui-${PV} 43 !<x11-libs/qt-gui-${PV}
41 !>x11-libs/qt-gui-${PV}-r9999 44 !>x11-libs/qt-gui-${PV}-r9999
42 !<x11-libs/qt-multimedia-${PV} 45 !<x11-libs/qt-multimedia-${PV}
63 66
64S=${WORKDIR}/${MY_P} 67S=${WORKDIR}/${MY_P}
65 68
66# @FUNCTION: qt4-build_pkg_setup 69# @FUNCTION: qt4-build_pkg_setup
67# @DESCRIPTION: 70# @DESCRIPTION:
68# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 71# Sets up PATH and LD_LIBRARY_PATH.
69qt4-build_pkg_setup() { 72qt4-build_pkg_setup() {
70 if [[ "${PN}" == "qt-webkit" ]]; then
71 if [[ "${CFLAGS}" =~ "-ggdb" ]] || [[ "${CXXFLAGS}" =~ "-ggdb" ]]; then
72 echo
73 ewarn "Your \$C{,XX}FLAGS contain -ggdb. You may experience really"
74 ewarn "long compilation times and/or increased memory usage."
75 ewarn "If compilation fails, please try removing -ggdb before"
76 ewarn "reporting a bug."
77 ewarn "For more info check out bug #307861"
78 echo
79 fi
80 fi
81
82 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 73 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
83 74
84 # Protect users by not allowing downgrades between releases 75 # Protect users by not allowing downgrades between releases
85 # Downgrading revisions within the same release should be allowed 76 # Downgrading revisions within the same release should be allowed
86 if has_version '>'${CATEGORY}/${P}-r9999 ; then 77 if has_version '>'${CATEGORY}/${P}-r9999; then
87 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 78 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
88 eerror "Sanity check to keep you from breaking your system:" 79 eerror "Sanity check to keep you from breaking your system:"
89 eerror " Downgrading Qt is completely unsupported and will break your system!" 80 eerror " Downgrading Qt is completely unsupported and will break your system!"
90 die "aborting to save your system" 81 die "aborting to save your system"
91 else 82 else
92 ewarn "Downgrading Qt is completely unsupported and will break your system!" 83 ewarn "Downgrading Qt is completely unsupported and will break your system!"
93 fi 84 fi
85 fi
86
87 if [[ ${PN} == "qt-webkit" ]]; then
88 eshopts_push -s extglob
89 if is-flagq '-g?(gdb)?([1-9])'; then
90 echo
91 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
92 ewarn "You may experience really long compilation times and/or increased memory usage."
93 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
94 ewarn "For more info check out bug #307861"
95 echo
96 fi
97 eshopts_pop
94 fi 98 fi
95 99
96 PATH="${S}/bin${PATH:+:}${PATH}" 100 PATH="${S}/bin${PATH:+:}${PATH}"
97 if [[ ${CHOST} != *-darwin* ]]; then 101 if [[ ${CHOST} != *-darwin* ]]; then
98 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 102 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
119 fi 123 fi
120} 124}
121 125
122# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 126# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
123# @DESCRIPTION: 127# @DESCRIPTION:
124# Arguments for build_target_directories. Takes the directories, in which the 128# Arguments for build_target_directories. Takes the directories in which the
125# code should be compiled. This is a space-separated list 129# code should be compiled. This is a space-separated list.
126 130
127# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 131# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
128# @DESCRIPTION: 132# @DESCRIPTION:
129# Space separated list including the directories that will be extracted from Qt 133# Space-separated list including the directories that will be extracted from
130# tarball 134# Qt tarball.
131 135
132# @FUNCTION: qt4-build_src_unpack 136# @FUNCTION: qt4-build_src_unpack
133# @DESCRIPTION: 137# @DESCRIPTION:
134# Unpacks the sources 138# Unpacks the sources.
135qt4-build_src_unpack() { 139qt4-build_src_unpack() {
136 setqtenv 140 setqtenv
137 local target targets= 141
142 local tarball="${MY_P}.tar.gz" target= targets=
138 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 143 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
139 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 144 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
140 ${QT4_EXTRACT_DIRECTORIES}; do 145 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
146 do
141 targets+=" ${MY_P}/${target}" 147 targets+="${MY_P}/${target} "
142 done 148 done
143 149
150 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
144 echo tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 151 tar -xzf "${DISTDIR}/${tarball}" ${targets}
145 tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 152 eend $? || die "failed to unpack"
146} 153}
147 154
148# @ECLASS-VARIABLE: PATCHES 155# @ECLASS-VARIABLE: PATCHES
156# @DEFAULT_UNSET
149# @DESCRIPTION: 157# @DESCRIPTION:
150# In case you have patches to apply, specify them in PATCHES variable. Make sure 158# PATCHES array variable containing all various patches to be applied.
151# to specify the full path. This variable is necessary for src_prepare phase. 159# This variable is expected to be defined in global scope of ebuild.
152# example: 160# Make sure to specify the full path. This variable is utilised in
153# PATCHES="${FILESDIR}"/mypatch.patch 161# src_unpack/src_prepare phase, based on EAPI.
154# ${FILESDIR}"/mypatch2.patch"
155# 162#
163# @CODE
164# PATCHES=( "${FILESDIR}/mypatch.patch"
165# "${FILESDIR}/patches_folder/" )
166# @CODE
156 167
157# @FUNCTION: qt4-build_src_prepare 168# @FUNCTION: qt4-build_src_prepare
158# @DESCRIPTION: 169# @DESCRIPTION:
159# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 170# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
160# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 171# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
161qt4-build_src_prepare() { 172qt4-build_src_prepare() {
162 setqtenv 173 setqtenv
163 cd "${S}" 174 cd "${S}"
164 175
165 # fix qt 4.7 regression that skips -fvisibility=hidden 176 if version_is_at_least "4.7"; then
166 if [[ "${PV}" == "4.7.0_beta1" ]]; then 177 # fix libX11 dependency on non X packages
167 sed -e "s/^gcc|g++)/*gcc|*g++)/" \ 178 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
168 -i config.tests/unix/fvisibility.test || 179 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
169 die "visibility fixing sed failed" 180
181 qt_assistant_cleanup
170 fi 182 fi
171 183
172 if use aqua; then 184 if use aqua; then
173 # provide a proper macx-g++-64 185 # provide a proper macx-g++-64
174 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 186 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
175 187
176 sed -e '/^CONFIG/s:app_bundle::' \ 188 sed -e '/^CONFIG/s:app_bundle::' \
177 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 189 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
178 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 190 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
179 fi 191 fi
180 192
181 if [[ ${PN} != qt-core ]]; then 193 if [[ ${PN} != qt-core ]]; then
182 skip_qmake_build_patch 194 skip_qmake_build
183 skip_project_generation_patch 195 skip_project_generation
184 symlink_binaries_to_buildtree 196 symlink_binaries_to_buildtree
185 fi 197 fi
186 198
187 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 199 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then
188 # qmake bus errors with -O2 but -O3 works 200 # qmake bus errors with -O2 but -O3 works
191 203
192 # Bug 178652 204 # Bug 178652
193 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 205 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
194 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 206 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
195 append-flags -fno-gcse 207 append-flags -fno-gcse
208 fi
209
210 if use_if_iuse c++0x; then
211 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
212 ewarn "this is an official standard, some of the reverse dependencies"
213 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
214 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
215 ewarn "disabled."
216 append-flags -std=c++0x
196 fi 217 fi
197 218
198 # Unsupported old gcc versions - hardened needs this :( 219 # Unsupported old gcc versions - hardened needs this :(
199 if [[ $(gcc-major-version) -lt 4 ]] ; then 220 if [[ $(gcc-major-version) -lt 4 ]] ; then
200 ewarn "Appending -fno-stack-protector to CXXFLAGS" 221 ewarn "Appending -fno-stack-protector to CXXFLAGS"
201 append-cxxflags -fno-stack-protector 222 append-cxxflags -fno-stack-protector
202 # Bug 253127 223 # Bug 253127
203 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 224 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
204 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 225 -i mkspecs/common/g++.conf || die
205 fi 226 fi
206 227
207 # Bug 261632 228 # Bug 261632
208 if use ppc64; then 229 if use ppc64; then
209 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 230 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
210 append-flags -mminimal-toc 231 append-flags -mminimal-toc
211 fi 232 fi
212 233
213 # Bug 282984 && Bug 295530 234 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
214 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 235 sed -e "/^SYSTEM_VARIABLES=/i \
215 -i configure || die "sed qmake compilers failed" 236 CC='$(tc-getCC)'\n\
216 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX) LINK=$(tc-getCXX):" \ 237 CXX='$(tc-getCXX)'\n\
217 -i config.tests/unix/compile.test || die "sed test compilers failed" 238 CFLAGS='${CFLAGS}'\n\
239 CXXFLAGS='${CXXFLAGS}'\n\
240 LDFLAGS='${LDFLAGS}'\n" \
241 -i configure \
242 || die "sed SYSTEM_VARIABLES failed"
243
244 # Respect CC, CXX, LINK and *FLAGS in config.tests
245 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
246 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
247 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
248 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
249 || die "sed config.tests failed"
250
251 # Strip predefined CFLAGS from mkspecs (bug 312689)
252 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
218 253
219 # Bug 172219 254 # Bug 172219
220 sed -e "s:X11R6/::" \ 255 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
221 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
222 256
223 if [[ ${CHOST} == *-darwin* ]]; then 257 if [[ ${CHOST} == *-darwin* ]]; then
224 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 258 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
225 # crippled (by design) :/ 259 # crippled (by design) :/
260 sed \
226 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 261 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
227 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 262 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
228 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 263 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
229 -e "s:-arch\s\w*::g" \ 264 -e "s:-arch\s\w*::g" \
230 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 265 -i mkspecs/common/mac-g++.conf \
266 || die "sed mkspecs/common/mac-g++.conf failed"
231 267
232 # Fix configure's -arch settings that appear in qmake/Makefile and also 268 # Fix configure's -arch settings that appear in qmake/Makefile and also
233 # fix arch handling (automagically duplicates our -arch arg and breaks 269 # fix arch handling (automagically duplicates our -arch arg and breaks
234 # pch). Additionally disable Xarch support. 270 # pch). Additionally disable Xarch support.
235 sed \ 271 sed \
240 -e "s:-arch \$i::" \ 276 -e "s:-arch \$i::" \
241 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 277 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
242 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 278 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
243 -e "s:-Xarch_x86_64::g" \ 279 -e "s:-Xarch_x86_64::g" \
244 -e "s:-Xarch_ppc64::g" \ 280 -e "s:-Xarch_ppc64::g" \
245 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 281 -i configure mkspecs/common/mac-g++.conf \
282 || die "sed -arch/-Xarch failed"
246 283
247 # On Snow Leopard don't fall back to 10.5 deployment target. 284 # On Snow Leopard don't fall back to 10.5 deployment target.
248 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 285 if [[ ${CHOST} == *-apple-darwin10 ]] ; then
249 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 286 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
250 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 287 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
251 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 288 -i configure mkspecs/common/mac-g++.conf \
289 || die "sed deployment target failed"
252 fi 290 fi
253 fi 291 fi
254 292
255 # this one is needed for all systems with a separate -liconv, apart from 293 # this one is needed for all systems with a separate -liconv, apart from
256 # Darwin, for which the sources already cater for -liconv 294 # Darwin, for which the sources already cater for -liconv
257 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 295 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then
258 sed \ 296 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
259 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
260 -i config.tests/unix/iconv/iconv.pro \ 297 -i config.tests/unix/iconv/iconv.pro \
261 || die "sed on iconv.pro failed" 298 || die "sed iconv.pro failed"
262 fi 299 fi
263 300
264 # we need some patches for Solaris 301 # we need some patches for Solaris
265 sed -i \
266 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 302 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
267 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 303 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
268 # use GCC over SunStudio 304 # use GCC over SunStudio
269 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 305 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
270 # don't flirt with non-Prefix stuff, we're quite possessive 306 # do not flirt with non-Prefix stuff, we're quite possessive
271 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 307 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
272 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 308 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
273 309
274 base_src_prepare 310 base_src_prepare
275} 311}
284 # this one is needed for all systems with a separate -liconv, apart from 320 # this one is needed for all systems with a separate -liconv, apart from
285 # Darwin, for which the sources already cater for -liconv 321 # Darwin, for which the sources already cater for -liconv
286 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 322 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \
287 myconf+=" -liconv" 323 myconf+=" -liconv"
288 324
289 if has glib ${IUSE//+} && use glib; then 325 if use_if_iuse glib; then
290 # use -I, -L and -l from configure 326 # use -I, -L and -l from configure
291 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 327 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
292 # avoid the -pthread argument 328 # avoid the -pthread argument
293 myconf+=" ${glibflags//-pthread}" 329 myconf+=" ${glibflags//-pthread}"
294 unset glibflags 330 unset glibflags
295 fi 331 fi
296 332
333 if use_if_iuse qpa; then
334 ewarn
335 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
336 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
337 ewarn "disable it before reporting any bugs related to this useflag."
338 ewarn
339 myconf+=" -qpa"
340 fi
341
297 if use aqua ; then 342 if use aqua ; then
298 # On (snow) leopard use the new (frameworked) cocoa code. 343 # On (snow) leopard use the new (frameworked) cocoa code.
299 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 344 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then
300 myconf+=" -cocoa -framework" 345 myconf+=" -cocoa -framework"
301 346
302 # We are crazy and build cocoa + qt3support :-) 347 # We are crazy and build cocoa + qt3support :-)
303 if use qt3support; then 348 if use qt3support; then
304 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 349 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
305 -i configure 350 -i configure || die
306 fi 351 fi
307 352
308 # We need the source's headers, not the installed ones. 353 # We need the source's headers, not the installed ones.
309 myconf+=" -I${S}/include" 354 myconf+=" -I${S}/include"
310 355
318 fi 363 fi
319 364
320 echo ./configure ${myconf} 365 echo ./configure ${myconf}
321 ./configure ${myconf} || die "./configure failed" 366 ./configure ${myconf} || die "./configure failed"
322 myconf="" 367 myconf=""
368
369 prepare_directories ${QT4_TARGET_DIRECTORIES}
323} 370}
324 371
325# @FUNCTION: qt4-build_src_compile 372# @FUNCTION: qt4-build_src_compile
373# @DESCRIPTION:
326# @DESCRIPTION: Actual compile phase 374# Actual compile phase
327qt4-build_src_compile() { 375qt4-build_src_compile() {
328 setqtenv 376 setqtenv
329 377
330 build_directories ${QT4_TARGET_DIRECTORIES} 378 build_directories ${QT4_TARGET_DIRECTORIES}
331} 379}
332 380
381# @FUNCTION: qt4-build_src_test
382# @DESCRIPTION:
383# Runs tests only in target directories.
384qt4-build_src_test() {
385 for dir in ${QT4_TARGET_DIRECTORIES}; do
386 emake -j1 check -C ${dir}
387 done
388}
389
333# @FUNCTION: fix_includes 390# @FUNCTION: fix_includes
334# @DESCRIPTION: 391# @DESCRIPTION:
335# For MacOSX we need to add some symlinks when frameworks are 392# For MacOS X we need to add some symlinks when frameworks are
336# being used, to avoid complications with some more or less stupid packages. 393# being used, to avoid complications with some more or less stupid packages.
337fix_includes() { 394fix_includes() {
338 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 395 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then
339 # Some packages tend to include <Qt/...> 396 # Some packages tend to include <Qt/...>
340 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 397 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
341 398
342 # Fake normal headers when frameworks are installed... eases life later on 399 # Fake normal headers when frameworks are installed... eases life later on
343 local dest f 400 local dest f h
344 for frw in "${D}${QTLIBDIR}"/*.framework; do 401 for frw in "${D}${QTLIBDIR}"/*.framework; do
345 [[ -e "${frw}"/Headers ]] || continue 402 [[ -e "${frw}"/Headers ]] || continue
346 f=$(basename ${frw}) 403 f=$(basename ${frw})
347 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 404 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
348 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 405 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
360# @DESCRIPTION: 417# @DESCRIPTION:
361# Perform the actual installation including some library fixes. 418# Perform the actual installation including some library fixes.
362qt4-build_src_install() { 419qt4-build_src_install() {
363 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D} 420 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
364 setqtenv 421 setqtenv
422
365 install_directories ${QT4_TARGET_DIRECTORIES} 423 install_directories ${QT4_TARGET_DIRECTORIES}
366 install_qconfigs 424 install_qconfigs
367 fix_library_files 425 fix_library_files
368 fix_includes 426 fix_includes
427
428 # remove .la files since we are building only shared Qt libraries
429 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
369} 430}
370 431
371# @FUNCTION: setqtenv 432# @FUNCTION: setqtenv
433# @INTERNAL
372setqtenv() { 434setqtenv() {
373 # Set up installation directories 435 # Set up installation directories
374 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
375 QTPREFIXDIR=${EPREFIX}/usr 436 QTPREFIXDIR=${EPREFIX}/usr
376 QTBINDIR=${EPREFIX}/usr/bin 437 QTBINDIR=${EPREFIX}/usr/bin
377 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 438 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
378 QMAKE_LIBDIR_QT=${QTLIBDIR}
379 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 439 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
380 QTDATADIR=${EPREFIX}/usr/share/qt4
381 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 440 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
382 QTHEADERDIR=${EPREFIX}/usr/include/qt4 441 QTHEADERDIR=${EPREFIX}/usr/include/qt4
383 QTPLUGINDIR=${QTLIBDIR}/plugins 442 QTPLUGINDIR=${QTLIBDIR}/plugins
443 QTIMPORTDIR=${QTLIBDIR}/imports
444 QTDATADIR=${EPREFIX}/usr/share/qt4
445 QTTRANSDIR=${QTDATADIR}/translations
384 QTSYSCONFDIR=${EPREFIX}/etc/qt4 446 QTSYSCONFDIR=${EPREFIX}/etc/qt4
385 QTTRANSDIR=${QTDATADIR}/translations
386 QTEXAMPLESDIR=${QTDATADIR}/examples 447 QTEXAMPLESDIR=${QTDATADIR}/examples
387 QTDEMOSDIR=${QTDATADIR}/demos 448 QTDEMOSDIR=${QTDATADIR}/demos
449 QMAKE_LIBDIR_QT=${QTLIBDIR}
388 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 450 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
451
389 PLATFORM=$(qt_mkspecs_dir) 452 PLATFORM=$(qt_mkspecs_dir)
390 453
391 unset QMAKESPEC 454 unset QMAKESPEC
392} 455}
393 456
394# @FUNCTION: standard_configure_options 457# @FUNCTION: standard_configure_options
458# @INTERNAL
395# @DESCRIPTION: 459# @DESCRIPTION:
396# Sets up some standard configure options, like libdir (if necessary), whether 460# Sets up some standard configure options, like libdir (if necessary), whether
397# debug info is wanted or not. 461# debug info is wanted or not.
398standard_configure_options() { 462standard_configure_options() {
399 local myconf= 463 local myconf="-prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
464 -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} -plugindir ${QTPLUGINDIR}
465 -importdir ${QTIMPORTDIR} -datadir ${QTDATADIR} -translationdir ${QTTRANSDIR}
466 -sysconfdir ${QTSYSCONFDIR} -examplesdir ${QTEXAMPLESDIR} -demosdir ${QTDEMOSDIR}
467 -opensource -confirm-license -shared -fast -largefile -stl -verbose
468 -platform $(qt_mkspecs_dir) -nomake examples -nomake demos"
400 469
401 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)" 470 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
402 471
403 # Disable visibility explicitly if gcc version isn't 4 472 # debug/release
404 if [[ $(gcc-major-version) -lt 4 ]]; then
405 myconf+=" -no-reduce-exports"
406 fi
407
408 # precompiled headers doesn't work on hardened, where the flag is masked.
409 myconf+=" $(qt_use pch)"
410
411 if use debug; then 473 if use debug; then
412 myconf+=" -debug" 474 myconf+=" -debug"
413 else 475 else
414 myconf+=" -release" 476 myconf+=" -release"
415 fi 477 fi
416 myconf+=" -no-separate-debug-info" 478 myconf+=" -no-separate-debug-info"
417 479
480 # exceptions USE flag
481 local exceptions="-exceptions"
482 in_iuse exceptions && exceptions="$(qt_use exceptions)"
483 myconf+=" ${exceptions}"
484
485 # disable RPATH on Qt >= 4.8 (bug 380415)
486 version_is_at_least 4.8 && myconf+=" -no-rpath"
487
488 # precompiled headers don't work on hardened, where the flag is masked
489 myconf+=" $(qt_use pch)"
490
491 # -reduce-relocations
492 # This flag seems to introduce major breakage to applications,
493 # mostly to be seen as a core dump with the message "QPixmap: Must
494 # construct a QApplication before a QPaintDevice" on Solaris.
495 # -- Daniel Vergien
496 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
497
418 use aqua && myconf+=" -no-framework" 498 use aqua && myconf+=" -no-framework"
419 499
420 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 500 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
421 # $(tc-arch). Therefore we convert it to supported values. 501 # $(tc-arch). Therefore we convert it to supported values.
422 case "$(tc-arch)" in 502 case "$(tc-arch)" in
423 amd64|x64-*) myconf+=" -arch x86_64" ;; 503 amd64|x64-*) myconf+=" -arch x86_64" ;;
424 ppc-macos) myconf+=" -arch ppc" ;; 504 ppc-macos) myconf+=" -arch ppc" ;;
425 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;; 505 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
426 sparc|sparc-*) myconf+=" -arch sparc" ;; 506 sparc|sparc-*|sparc64-*) myconf+=" -arch sparc" ;;
427 x86-macos) myconf+=" -arch x86" ;; 507 x86-macos) myconf+=" -arch x86" ;;
428 x86|x86-*) myconf+=" -arch i386" ;; 508 x86|x86-*) myconf+=" -arch i386" ;;
429 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;; 509 alpha|arm|ia64|mips|s390) myconf+=" -arch $(tc-arch)" ;;
430 hppa|sh) myconf+=" -arch generic" ;; 510 hppa|sh) myconf+=" -arch generic" ;;
431 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 511 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
432 esac 512 esac
433 513
434 # 4.5: build everything but qt-xmlpatterns w/o exceptions
435 # 4.6: exceptions USE flag
436 local exceptions="-exceptions"
437 case "${PV}" in
438 4.5.*)
439 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
440 ;;
441 *)
442 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
443 ;;
444 esac
445
446 # note about -reduce-relocations:
447 # That flag seems to introduce major breakage to applications,
448 # mostly to be seen as a core dump with the message "QPixmap: Must
449 # construct a QApplication before a QPaintDevice" on Solaris
450 # -- Daniel Vergien
451 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
452
453 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
454 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
455 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
456 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
457 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
458 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
459 ${exceptions}
460 -nomake examples -nomake demos"
461
462 echo "${myconf}" 514 echo "${myconf}"
463} 515}
464 516
465# @FUNCTION: build_directories 517# @FUNCTION: prepare_directories
466# @USAGE: < directories > 518# @USAGE: < directories >
519# @INTERNAL
467# @DESCRIPTION: 520# @DESCRIPTION:
468# Compiles the code in $QT4_TARGET_DIRECTORIES 521# Generates Makefiles for the given list of directories.
469build_directories() { 522prepare_directories() {
470 for x in "$@"; do 523 for x in "$@"; do
471 pushd "${S}"/${x} >/dev/null 524 pushd "${S}"/${x} >/dev/null || die
525 einfo "Running qmake in: ${x}"
472 # avoid running over the maximum argument number, bug #299810 526 # avoid running over the maximum argument number, bug #299810
473 { 527 {
474 echo "${S}"/mkspecs/common/*.conf 528 echo "${S}"/mkspecs/common/*.conf
475 find "${S}" -name '*.pr[io]' 529 find "${S}" -name '*.pr[io]'
476 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 530 } | xargs sed -i \
531 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
532 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
533 || die
477 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 534 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
535 popd >/dev/null || die
536 done
537}
538
539
540# @FUNCTION: build_directories
541# @USAGE: < directories >
542# @INTERNAL
543# @DESCRIPTION:
544# Compiles the code in the given list of directories.
545build_directories() {
546 for x in "$@"; do
547 pushd "${S}"/${x} >/dev/null || die
478 emake CC="$(tc-getCC)" \ 548 emake CC="$(tc-getCC)" \
479 CXX="$(tc-getCXX)" \ 549 CXX="$(tc-getCXX)" \
480 LINK="$(tc-getCXX)" || die "emake failed" 550 LINK="$(tc-getCXX)" || die "emake failed"
481 popd >/dev/null 551 popd >/dev/null || die
482 done 552 done
483} 553}
484 554
485# @FUNCTION: install_directories 555# @FUNCTION: install_directories
486# @USAGE: < directories > 556# @USAGE: < directories >
557# @INTERNAL
487# @DESCRIPTION: 558# @DESCRIPTION:
488# run emake install in the given directories, which are separated by spaces 559# Runs emake install in the given directories, which are separated by spaces.
489install_directories() { 560install_directories() {
490 for x in "$@"; do 561 for x in "$@"; do
491 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 562 pushd "${S}"/${x} >/dev/null || die
492 emake INSTALL_ROOT="${D}" install || die "emake install failed" 563 emake INSTALL_ROOT="${D}" install || die "emake install failed"
493 popd >/dev/null || die "Can't popd from ${S}/${x}" 564 popd >/dev/null || die
494 done 565 done
495} 566}
496 567
497# @ECLASS-VARIABLE: QCONFIG_ADD 568# @ECLASS-VARIABLE: QCONFIG_ADD
498# @DESCRIPTION: 569# @DESCRIPTION:
508# @DESCRIPTION: 579# @DESCRIPTION:
509# List variables that should be defined at the top of QtCore/qconfig.h 580# List variables that should be defined at the top of QtCore/qconfig.h
510: ${QCONFIG_DEFINE:=} 581: ${QCONFIG_DEFINE:=}
511 582
512# @FUNCTION: install_qconfigs 583# @FUNCTION: install_qconfigs
584# @INTERNAL
585# @DESCRIPTION:
513# @DESCRIPTION: Install gentoo-specific mkspecs configurations 586# Install gentoo-specific mkspecs configurations.
514install_qconfigs() { 587install_qconfigs() {
515 local x 588 local x
516 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 589 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
517 for x in QCONFIG_ADD QCONFIG_REMOVE; do 590 for x in QCONFIG_ADD QCONFIG_REMOVE; do
518 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 591 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
529 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 602 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
530 fi 603 fi
531} 604}
532 605
533# @FUNCTION: generate_qconfigs 606# @FUNCTION: generate_qconfigs
534# @DESCRIPTION: Generates gentoo-specific configurations 607# @INTERNAL
608# @DESCRIPTION:
609# Generates gentoo-specific qconfig.{h,pri}.
535generate_qconfigs() { 610generate_qconfigs() {
536 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 611 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then
537 local x qconfig_add qconfig_remove qconfig_new 612 local x qconfig_add qconfig_remove qconfig_new
538 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 613 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
539 [[ -f ${x} ]] || continue 614 [[ -f ${x} ]] || continue
553 628
554 # generate list of QT_CONFIG entries from the existing list 629 # generate list of QT_CONFIG entries from the existing list
555 # including qconfig_add and excluding qconfig_remove 630 # including qconfig_add and excluding qconfig_remove
556 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 631 for x in $(sed -n 's/^QT_CONFIG +=//p' \
557 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 632 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
558 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 633 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
559 done 634 done
560 635
561 # replace the existing QT_CONFIG list with qconfig_new 636 # replace the existing QT_CONFIG list with qconfig_new
562 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 637 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
563 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 638 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
587 fi 662 fi
588 fi 663 fi
589} 664}
590 665
591# @FUNCTION: qt4-build_pkg_postrm 666# @FUNCTION: qt4-build_pkg_postrm
667# @DESCRIPTION:
592# @DESCRIPTION: Generate configurations when the package is completely removed 668# Regenerate configuration when the package is completely removed.
593qt4-build_pkg_postrm() { 669qt4-build_pkg_postrm() {
594 generate_qconfigs 670 generate_qconfigs
595} 671}
596 672
597# @FUNCTION: qt4-build_pkg_postinst 673# @FUNCTION: qt4-build_pkg_postinst
674# @DESCRIPTION:
598# @DESCRIPTION: Generate configuration, plus throws a message about possible 675# Regenerate configuration, plus throw a message about possible
599# breakages and proposed solutions. 676# breakages and proposed solutions.
600qt4-build_pkg_postinst() { 677qt4-build_pkg_postinst() {
601 generate_qconfigs 678 generate_qconfigs
602} 679}
603 680
604# @FUNCTION: skip_qmake_build_patch 681# @FUNCTION: skip_qmake_build
682# @INTERNAL
605# @DESCRIPTION: 683# @DESCRIPTION:
606# Don't need to build qmake, as it's already installed from qt-core 684# Patches configure to skip qmake compilation, as it's already installed by qt-core.
607skip_qmake_build_patch() { 685skip_qmake_build() {
608 # Don't need to build qmake, as it's already installed from qt-core
609 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 686 sed -i -e "s:if true:if false:g" "${S}"/configure || die
610} 687}
611 688
612# @FUNCTION: skip_project_generation_patch 689# @FUNCTION: skip_project_generation
690# @INTERNAL
613# @DESCRIPTION: 691# @DESCRIPTION:
614# Exit the script early by throwing in an exit before all of the .pro files are scanned 692# Exit the script early by throwing in an exit before all of the .pro files are scanned.
615skip_project_generation_patch() { 693skip_project_generation() {
616 # Exit the script early by throwing in an exit before all of the .pro files are scanned
617 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 694 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
618 -i "${S}"/configure || die "Sed failed"
619} 695}
620 696
621# @FUNCTION: symlink_binaries_to_buildtree 697# @FUNCTION: symlink_binaries_to_buildtree
698# @INTERNAL
622# @DESCRIPTION: 699# @DESCRIPTION:
623# Symlink generated binaries to buildtree so they can be used during compilation 700# Symlinks generated binaries to buildtree, so they can be used during compilation time.
624# time
625symlink_binaries_to_buildtree() { 701symlink_binaries_to_buildtree() {
626 for bin in qmake moc uic rcc; do 702 for bin in qmake moc uic rcc; do
627 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 703 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
628 done 704 done
629} 705}
630 706
631# @FUNCTION: fix_library_files 707# @FUNCTION: fix_library_files
708# @INTERNAL
632# @DESCRIPTION: 709# @DESCRIPTION:
633# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 710# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
634# moves the *.pc-files into the pkgconfig directory 711# moves the *.pc files into the pkgconfig directory.
635fix_library_files() { 712fix_library_files() {
713 local libfile
636 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 714 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
637 if [[ -e ${libfile} ]]; then 715 if [[ -e ${libfile} ]]; then
638 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 716 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
639 fi 717 fi
640 done 718 done
641 719
642 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 720 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
643 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 721 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
644 if [[ -e ${libfile} ]]; then 722 if [[ -e ${libfile} ]]; then
645 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 723 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
646 724
647 # Move .pc files into the pkgconfig directory 725 # Move .pc files into the pkgconfig directory
648 dodir ${QTPCDIR#${EPREFIX}} 726 dodir ${QTPCDIR#${EPREFIX}}
649 mv ${libfile} "${D}"/${QTPCDIR}/ \ 727 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
650 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
651 fi 728 fi
652 done 729 done
653 730
654 # Don't install an empty directory 731 # Don't install an empty directory
655 rmdir "${D}"/${QTLIBDIR}/pkgconfig 732 rmdir "${D}"/${QTLIBDIR}/pkgconfig
656} 733}
657 734
658# @FUNCTION: qt_use 735# @FUNCTION: qt_use
659# @USAGE: < flag > [ feature ] [ enableval ] 736# @USAGE: < flag > [ feature ] [ enableval ]
660# @DESCRIPTION: 737# @DESCRIPTION:
661# This will echo "${enableval}-${feature}" if <flag> is enabled, or 738# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
662# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 739# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
663# will be used for that. If [enableval] is not specified, it omits the 740# will be used for that. If [enableval] is not specified, it omits the
664# assignment-part 741# "-${enableval}" part.
665qt_use() { 742qt_use() {
666 local flag=$1 743 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
667 local feature=$1
668 local enableval=
669
670 [[ -n $2 ]] && feature=$2
671 [[ -n $3 ]] && enableval=-$3
672
673 if use ${flag}; then
674 echo "${enableval}-${feature}"
675 else
676 echo "-no-${feature}"
677 fi
678} 744}
679 745
680# @FUNCTION: qt_mkspecs_dir 746# @FUNCTION: qt_mkspecs_dir
681# @RETURN: the specs-directory w/o path 747# @RETURN: the specs-directory w/o path
682# @DESCRIPTION: 748# @DESCRIPTION:
683# Allows us to define which mkspecs dir we want to use. 749# Allows us to define which mkspecs dir we want to use.
684qt_mkspecs_dir() { 750qt_mkspecs_dir() {
685 # Allows us to define which mkspecs dir we want to use.
686 local spec 751 local spec=
687
688 case ${CHOST} in 752 case ${CHOST} in
689 *-freebsd*|*-dragonfly*) 753 *-freebsd*|*-dragonfly*)
690 spec=freebsd ;; 754 spec=freebsd ;;
691 *-openbsd*) 755 *-openbsd*)
692 spec=openbsd ;; 756 spec=openbsd ;;
704 *-solaris*) 768 *-solaris*)
705 spec=solaris ;; 769 spec=solaris ;;
706 *-linux-*|*-linux) 770 *-linux-*|*-linux)
707 spec=linux ;; 771 spec=linux ;;
708 *) 772 *)
709 die "Unknown CHOST, no platform choosen." 773 die "Unknown CHOST, no platform chosen"
710 esac 774 esac
711 775
712 CXX=$(tc-getCXX) 776 CXX=$(tc-getCXX)
713 if [[ ${CXX} == *g++* ]]; then 777 if [[ ${CXX} == *g++* ]]; then
714 spec+=-g++ 778 spec+=-g++
715 elif [[ ${CXX} == *icpc* ]]; then 779 elif [[ ${CXX} == *icpc* ]]; then
716 spec+=-icc 780 spec+=-icc
717 else 781 else
718 die "Unknown compiler ${CXX}." 782 die "Unknown compiler '${CXX}'"
719 fi 783 fi
720 if [[ -n ${LIBDIR/lib} ]]; then 784 if [[ -n ${LIBDIR/lib} ]]; then
721 spec+=-${LIBDIR/lib} 785 spec+=-${LIBDIR/lib}
722 fi 786 fi
723 787
732 fi 796 fi
733 797
734 echo "${spec}" 798 echo "${spec}"
735} 799}
736 800
801# @FUNCTION: qt_assistant_cleanup
802# @INTERNAL
803# @DESCRIPTION:
804# Tries to clean up tools.pro for qt-assistant ebuilds.
805# Meant to be called in src_prepare().
806# Since Qt 4.7.4 this function is a no-op.
807qt_assistant_cleanup() {
808 # apply patching to qt-assistant ebuilds only
809 [[ ${PN} != "qt-assistant" ]] && return
810
811 # no longer needed for 4.7.4 and later
812 version_is_at_least "4.7.4" && return
813
814 # different versions (and branches...) may need different handling,
815 # add a case if you need special handling
816 case "${MY_PV_EXTRA}" in
817 *kde-qt*)
818 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
819 -e "/mac/,/^embedded.*makeqpf$/d" \
820 -i tools/tools.pro || die "patching tools.pro failed"
821 ;;
822 *)
823 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
824 -e "/mac/,/^embedded.*makeqpf$/d" \
825 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
826 -i tools/tools.pro || die "patching tools.pro failed"
827 ;;
828 esac
829}
830
831# @FUNCTION: qt_nolibx11
832# @INTERNAL
833# @DESCRIPTION:
834# Ignore X11 tests for packages that don't need X libraries installed.
835qt_nolibx11() {
836 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
837 die "x11 check sed failed"
838}
839
737EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst 840EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.69  
changed lines
  Added in v.1.114

  ViewVC Help
Powered by ViewVC 1.1.20